﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Eloquera.Client;

namespace Benchmarking.Eloquera
{
    public class EloqueraBenchmark : BaseBenchmark
    {
      static DB eloquera;

        public EloqueraBenchmark()
        {
            Name = "Eloquera";
            Description = Name;
            Website = "http://eloquera.com/";
            Color = Color.Cornsilk;
            TransactionMode = false;
            Requirements = new string[] { 
                "Eloquera.Client.dll"
            };
        }

        public override void CreateDatabase()
        {
          eloquera = new DB("server=(local);options=none;");
          DB.Configuration.ServerSettings.DatabasePath = WorkingDirectory;
          try
          {
            eloquera.DeleteDatabase("Ticks", true);
          }
          catch
          {
          }       
        }

        public override void Append()
        {
          eloquera.CreateDatabase("Ticks");
          eloquera.OpenDatabase("Ticks");
            //insert records
            ulong i = 0;
            foreach (var record in Tick.GenerateRandom(RecordCount))
            {
               eloquera.Store(record);
                //progress in %
                Progress = (i / (double)RecordCount) * 100.0;
                i++;
            }
            eloquera.Close();
        }

        public override void Enumerate()
        {
          eloquera.OpenDatabase("Ticks"); 
          ulong i = 0; 
          IEnumerable<Tick> items =
          (from Tick tick in eloquera
            select tick);

          foreach (var tick in items)
          {
            //progress in %
            Progress = (i / RecordCount) * 100.0;
            i++;
          }
        }

        public override void Clone()
        {

        }

        public override void Update()
        {

        }

        public override void RandomAccess()
        {

        }

        public override void SortByDouble()
        {

        }

        public override void SortByStringThenByDateTime()
        {

        }

        public override void Delete()
        {

        }

        public override void MultiTableInsert()
        {

        }

        public override void DateTimeInsert()
        {

        }

        public override void DateTimeAscendingEnumerate()
        {
  
        }

        public override void DateTimeDescendingEnumerate()
        {

        }

        public override void RandomInsert()
        {

        }

        public override void EnumerateFragmented()
        {

        }
    }
}
